// DUEL (PC88) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*16*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(&buff[_offset], 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[FILENAME_MAX];
	int i,d;
	int dn=0;
	char id1[] = "S E T [ V 2 ] M O D E";
	char id2[] = {0xd1, 0x3c, 0xd1, 0x66};
	char id3[] = "DUEL(C)K.S.K";

	// ȃf[^ʒu
	struct fpos md1[] =
	{
		{ 0x04, 0x01, 0x0600 },	//
		{ 0x04, 0x07, 0x0600 },	//
		{ 0x04, 0x0d, 0x0600 },	//
		{ 0x05, 0x03, 0x0600 },	//
		{ 0x05, 0x09, 0x0600 },	//
		{ 0x05, 0x0f, 0x0600 },	//
		{ 0x06, 0x05, 0x0600 },	//
		{ 0x00, 0x00, 0x0000 },	// End of Data
	};

	struct fpos md2[] =
	{
		{ 0x04, 0x01, 0x0600 },	//
		{ 0x04, 0x07, 0x0600 },	//
		{ 0x04, 0x0d, 0x0600 },	//
		{ 0x05, 0x03, 0x0600 },	//
		{ 0x05, 0x09, 0x0600 },	//
		{ 0x05, 0x0f, 0x0600 },	//
		{ 0x06, 0x05, 0x0600 },	//
		{ 0x06, 0x0b, 0x0600 },	//
		{ 0x00, 0x00, 0x0000 },	// End of Data
	};

	struct fpos md3[] =
	{
		{ 0x04, 0x01, 0x0600 },	//
		{ 0x04, 0x07, 0x0600 },	//
		{ 0x04, 0x0d, 0x0600 },	//
		{ 0x05, 0x03, 0x0600 },	//
		{ 0x05, 0x09, 0x0600 },	//
		{ 0x05, 0x0f, 0x0600 },	//
		{ 0x06, 0x05, 0x0600 },	//
		{ 0x07, 0x09, 0x0600 },	//
		{ 0x00, 0x00, 0x0000 },	// End of Data
	};

	if (argc<2 || argc>3)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file] (DiskNo.)\n",argv[0]);
		return 1;
	}

	if (argc==3)
	{
		// fBXNԍw
		dn = *argv[2]-'0';
		if (dn<1 || dn>6)
		{
		fprintf(stderr, "Usage: %s [d88file] (DiskNo.)\n",argv[0]);
		return 1;
		}
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x10);
		// fBXN
		disk.ReadDATA1(0x00, 0x00, 0x00, 0x01, 0x01, buff, 0x100);
		if ((!memcmp(&buff[0x8c], id1, sizeof(id1)-1) && dn==0) || dn==1)
		{
			fprintf(stderr, "I[vjOfBXNF܂.\n");
			// 荞݃hCo
			fcut("INTDRV", 0x00, 0x00, 0x00, 0x0d, 0x01, 0x0000, 0x0400);
			fcut("MUSDRV", 0x42, 0x21, 0x00, 0x01, 0x01, 0x0000, 0x0700);
			fcut("OP1", 0x01, 0x00, 0x01, 0x01, 0x01, 0x0000, 0x1000);
			fcut("OP2", 0x01, 0x00, 0x01, 0x0a, 0x01, 0x0000, 0x0800);
			if (dn) return 0; else continue;
		}
		disk.ReadDATA1(0x13, 0x09, 0x01, 0x01, 0x01, buff, 0x100);
		if ((!memcmp(&buff[0x01], id2, sizeof(id2)-1) && dn==0) || dn==2 || dn==3)
		{
			if ((buff[0x00]==0x00 && dn==0) || dn==2)
			{
				fprintf(stderr, "LN^[fBXN(Real)F܂.\n");
				fcut("CHR1A", 0x02, 0x01, 0x00, 0x04, 0x01, 0x0040, 0x0cc0);
				fcut("CHR1B", 0x10, 0x08, 0x00, 0x01, 0x01, 0x0000, 0x0d00);
				if (dn) return 0; else continue;
			}
			else if ((buff[0x00]==0x01 && dn==0) || dn==3)
			{
				fprintf(stderr, "LN^[fBXN(Fantasy)F܂.\n");
				fcut("CHR2A", 0x02, 0x01, 0x00, 0x05, 0x01, 0x0000, 0x0c00);
				fcut("CHR2B", 0x10, 0x08, 0x00, 0x01, 0x01, 0x0000, 0x1000);
				if (dn) return 0; else continue;
			}
			else continue;
		}
		disk.ReadDATA1(0x01, 0x00, 0x01, 0x03, 0x01, buff, 0x100);
		if ((!memcmp(&buff[0x11], id3, sizeof(id3)-1) && dn==0) || (dn>=4 && dn<=6))
		{
			if (buff[0x10]==0x01 && dn==0 || dn==4)
			{
				fprintf(stderr, "}bvfBXN1(Glassland)F܂.\n");
				for (i=0; md1[i].sec; i++)
				{
					sprintf(fname,"MUS1%02d",i);
					fcut(fname, md1[i].trk, md1[i].trk>>1, md1[i].trk&1, md1[i].sec, 0x01, 0x0000, md1[i].size);
				}
				if (dn) return 0; else continue;
			}
			else if (buff[0x10]==0x02 && dn==0 || dn==5)
			{
				fprintf(stderr, "}bvfBXN2(Castle)F܂.\n");
				for (i=0; md2[i].sec; i++)
				{
					sprintf(fname,"MUS2%02d",i);
					fcut(fname, md2[i].trk, md2[i].trk>>1, md2[i].trk&1, md2[i].sec, 0x01, 0x0000, md2[i].size);
				}
				if (dn) return 0; else continue;
			}
			else if (buff[0x10]==0x03 && dn==0 || dn==6)
			{
				fprintf(stderr, "}bvfBXN3(Moon Hill)F܂.\n");
				for (i=0; md3[i].sec; i++)
				{
					sprintf(fname,"MUS3%02d",i);
					fcut(fname, md3[i].trk, md3[i].trk>>1, md3[i].trk&1, md3[i].sec, 0x01, 0x0000, md3[i].size);
				}
				if (dn) return 0; else continue;
			}
			else continue;
		}
	}
	return 0;
}

